﻿Type=Activity
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim TEXTO_PASSAR As String
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private confirmar As Button
	Private DESIGNACAO As Label
	Private ETIQUETAS As Label
	Private etiquetas_itens As Label
	Private FOTO As WebView
	Private Lb_entrada As Label
	Private LB_SINAL As Label
	Private MAIS_ETIQUETA As Button
	Private MENOS_ETIQUETA As Button
	Private NOME As Label
	Private PAINEL_ARTIGO As Panel
	Private QTT As Label
	Private REFERENCIA As Label
	Private SINAL As Label
	Private VENDEDOR As Label
	Private voltar_1 As Button
	Private STAMP As Label
	Private ENTRADA_N As Label
	Dim futur, futur_bold As Typeface
	Dim reqManager As DBRequestManager
	Private ST As StringFunctions
	Private stamp_id As String
	Private codigo_barras As String
	Private DATA_DOCUMENTO As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("FICHA_CORTES_SINAIS")
	futur=Typeface.LoadFromAssets("FUTURAM.ttf")
futur_bold=Typeface.LoadFromAssets("tt0141m_.ttf")
reqManager.Initialize(Me, Configuracoes.CONFIG1)
SetTypeface(Activity,futur)

End Sub

Sub Activity_Resume
If TEXTO_PASSAR="" Then 
	StartActivity("LISTA_CORTES_SINAIS")
	Activity.Finish
	Else
	CARREGAR_DADOS	
End If
End Sub


Sub SetTypeface(parent As Panel, t As Typeface)
   For Each v As View In parent
      If v Is Label Then
         Dim lbl As Label = v
         lbl.Typeface = t
      Else If v Is Panel Then
         SetTypeface(v, t)
      End If
   Next
   etiquetas_itens.Typeface=futur_bold
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub voltar_1_Click
	StartActivity("LISTA_CORTES_SINAIS")
	Activity.Finish
End Sub

Sub MENOS_ETIQUETA_Click
	If ETIQUETAS.Text="0" Then Return
	ETIQUETAS.Text=NumberFormat(ETIQUETAS.Text-1,1,0)
End Sub

Sub MAIS_ETIQUETA_Click
	If ETIQUETAS.Text="99" Then Return
	ETIQUETAS.Text=NumberFormat(ETIQUETAS.Text+1,1,0)
End Sub

Sub CARREGAR_DADOS
	Dim PARTIR() As String
	PARTIR=Regex.Split("\|",TEXTO_PASSAR)
	STAMP.Text=PARTIR(0).Trim
	ENTRADA_N.Text=PARTIR(1).Trim
	SINAL.Text=PARTIR(2).Trim
	VENDEDOR.Text=PARTIR(3).Trim
	QTT.Text=NumberFormat2(PARTIR(4),1,2,2,False)
	NOME.Text=PARTIR(5).Trim
	DESIGNACAO.Text=PARTIR(6).Trim
	REFERENCIA.Text=PARTIR(7).Trim
	codigo_barras=PARTIR(8).Trim
	DATA_DOCUMENTO=PARTIR(9).Trim
Dim HTML1 As String = PARTIR(7)
Dim FOTOTAPA As Panel
HTML1="<html><body background="""&Configuracoes.CONFIG2 & REFERENCIA.Text.Trim.ToUpperCase.trim &"_A.JPG"" style='background-size: 100% auto;'><body><html>"	
FOTO.LoadUrl("")
FOTO.LoadHtml(HTML1)
FOTO.Enabled=False
FOTO.ZoomEnabled=False
FOTO.Visible=False
FOTO.Visible=True
FOTOTAPA.Initialize("FOTOTAPA")
PAINEL_ARTIGO.AddView(FOTOTAPA,FOTO.Left,FOTO.Top,FOTO.Width,FOTO.Height)
End Sub

Sub FOTOTAPA_LongClick
	CallSubDelayed3(codigo_barras2,"carrega_imagens",REFERENCIA.TEXT & "_A.JPG","TESTE")	
End Sub

Sub confirmar_Click
Dim resposta As Int
resposta= Msgbox2( "DESEJA MARCAR O ARTIGO " & REFERENCIA.TEXT & " COMO CATIVO?" ,"CONFIRMAR CATIVO","Sim","","Não",LoadBitmap(File.DirAssets,"favicon.png"))
If resposta=DialogResponse.POSITIVE Then CONFIRMAR_CATIVO
End Sub

Sub CONFIRMAR_CATIVO
Dim cmd As DBCommand
cmd.Initialize
cmd.Name = "cativa_armazem"
cmd.Parameters = Array As Object(STAMP.TEXT)
reqManager.ExecuteCommand(cmd,"cativa_armazem")	
End Sub

Sub ENVIAR_ETIQUETAS(NUMERO_ETIQUETAS As Int)
	If ETIQUETAS.Text<>"0" Then 
	Try
		CRIA_STAMP_NUMERO_ORCAMENTO
		'ToastMessageShow(NUMERO_ETIQUETAS,False)
		
	Catch
		ToastMessageShow(LastException,False)
	End Try
	End If
	
End Sub

Sub CRIA_STAMP_NUMERO_ORCAMENTO
Dim pt1,pt2,pt3,pt4,pt5, timestamp As String
Dim pt30,pt31,pt32 As String
'pt1= st.Left(vendedor.Text,2)
pt1=NumberFormat(Main.numero_utilizador,3,0)
pt2=NumberFormat(ESCOLHER_FORNECEDOR.numero_forn,3,0)
'DateTime.DateFormat("dd/mm/yyyy")
pt30=NumberFormat(DateTime.GetDayOfMonth(DateTime.Now),2,0)
pt31=NumberFormat(DateTime.GetMonth(DateTime.Now),2,0)
pt32=NumberFormat(DateTime.GetYear(DateTime.Now),4,0)
pt3=pt30&"/"&pt31&"/"&pt32
pt4=DateTime.Time(DateTime.Now)
pt5=NumberFormat(Rnd(000000,999999),6,0)
timestamp=pt1&pt2&pt3&pt4&pt5
timestamp=timestamp.Replace("/","")
timestamp=timestamp.Replace(":","")
stamp_id="EE"&ST.Left(timestamp,23)
'ToastMessageShow(stamp_id.Text.Length,True)
ENVIAR_CABECALHO
End Sub

Sub ENVIAR_CABECALHO
Dim cmd As DBCommand
cmd.Initialize
cmd.Name = "etiquetas_cab"
cmd.Parameters = Array As Object(stamp_id,Main.vendedor_actual,"EntradaAPP")
reqManager.ExecuteCommand(cmd,"ENVIA_cabecalho")	
End Sub



Sub ENVIAR_LINHAS_NUMERO_ORCAMENTO
'############### verifica cabecalho #############
'############### verifica cabecalho #############
Try
	
'Dim chk12 As CheckBox
'Dim cabecALHO,EL1,EL2,EL3,EL4,EL5,EL6,EL7,EL8,EL9 As String
'############### verifica cabecalho #############
'############### verifica cabecalho #############
 

Dim obs1,obs2,obs3,obs4,obs5 As String
If SINAL.TEXT.IndexOf("(")>0 Then 
		obs1="O " & SINAL.TEXT
Else
		obs1="S " & SINAL.TEXT
End If
			
		obs2=REFERENCIA.Text
		obs3="Vol:   - " & QTT.TEXT
		obs4=DESIGNACAO.text
		obs5= VENDEDOR.TEXT & " - " & ST.Left(DATA_DOCUMENTO,10) & "  **CAT**" 

Dim cmd1 As DBCommand
cmd1.Initialize
cmd1.Name = "etiquetas_linha"
cmd1.Parameters = Array As Object(stamp_id,REFERENCIA.TEXT,ETIQUETAS.text,"0",obs1,obs2,obs3,obs4,obs5,codigo_barras)		
reqManager.ExecuteCommand(cmd1,"ENVIA_linhas_2")
Catch
	Msgbox(LastException,"Erro")
End Try

End Sub



Sub jobdone (job As HttpJob)
	If job.Success = False Then
 	Log("Error: " & job.ErrorMessage)
   	Else
     If job.JobName = "DBRequest" Then
       Dim result As DBResult = reqManager.HandleJob(job)

 '############### envia cabecalho etiquetas inicio #############
	   If result.Tag = "cativa_armazem" Then
	ENVIAR_ETIQUETAS(ETIQUETAS.TEXT)
	   End If

 '############### envia cabecalho etiquetas inicio #############
	   If result.Tag = "ENVIA_cabecalho" Then
	   	ENVIAR_LINHAS_NUMERO_ORCAMENTO
	   End If
 	   '############### envia linhas orcamento etiquetas fim #############
	   If result.Tag = "ENVIA_linhas_2" Then
ToastMessageShow("Etiqueta de Encomenda Enviada Aguarde a Impressão",True)
StartActivity("LISTA_CORTES_SINAIS")
	Activity.Finish
	   End If


	   
job.Release
End If
End If
End Sub
