﻿Type=Activity
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: TRUE
	#IncludeTitle: FALSE
#End Region
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim FORNECEDOR As String
	Dim numero_forn As Int
End Sub
Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private voltar_1 As Button
	Private etiquetas_itens As Label
	Private vendedor As Label
	Private FUTUR, FUTUR_BOLD As Typeface
	Private ReqManager As DBRequestManager
	Private lista_fornecedores As ListView
	Private st As StringFunctions
	Private btn_procura As Button
	Private procura As EditText
End Sub
Sub Activity_Create(FirstTime As Boolean)
Activity.LoadLayout("ESCOLHER_FORNECEDOR")
ReqManager.Initialize(Me, Configuracoes.CONFIG1)
FUTUR=Typeface.LoadFromAssets("FUTURAM.ttf")
FUTUR_BOLD=Typeface.LoadFromAssets("tt0141m_.ttf")
vendedor.Text=Main.vendedor_actual.ToUpperCase
vendedor.Typeface=FUTUR
vendedor.Text=Main.vendedor_actual
etiquetas_itens.Text="ESCOLHER FORNECEDOR"
 SetTypeface(Activity,FUTUR)
End Sub
Sub SetTypeface(parent As Panel, t As Typeface)
   For Each v As View In parent
      If v Is Label Then
         Dim lbl As Label = v
         lbl.Typeface = t
      Else If v Is Panel Then
         SetTypeface(v, t)
      End If
   Next
   etiquetas_itens.Typeface=FUTUR_BOLD
End Sub
Sub Activity_KeyPress (KeyCode As Int) As Boolean                     
   If KeyCode = KeyCodes.KEYCODE_BACK Then       
 'btn_voltar_Click
 Return True
   End If 
End Sub
Sub Activity_Resume
CARREGA_FORNECEDORES
End Sub
Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub vendedor_LongClick
	StartActivity(codigo_barras2)
End Sub
Sub voltar_1_Click
	StartActivity(MENU_ENTRADAS)
	Activity.Finish
End Sub

Sub CARREGA_FORNECEDORES
Dim cmd As DBCommand
cmd.Initialize
cmd.Name = "fornec_pickings"
'cmd.Parameters = Array As Object("Benfica","Carro","10.25")
ReqManager.ExecuteQuery(cmd,0,"fornec_pickings")
'reqManager.ExecuteCommand(cmd,0)
End Sub


Sub jobdone (job As HttpJob)
 If job.Success = False Then
     Log("Error: " & job.ErrorMessage)
   Else
     If job.JobName = "DBRequest" Then
       Dim result As DBResult = ReqManager.HandleJob(job)
	   'ToastMessageShow(result.Tag,True)
	   
	   '############### carrega utilizadores #############
	   '############### carrega utilizadores #############
	   
     
  	If result.Tag = "fornec_pickings" Then 'query tag
		If File.Exists(File.DirRootExternal,"nomalism/entradas/fornecedores.txt")=True Then  File.Delete(File.DirRootExternal,"nomalism/entradas/fornecedores.txt")
		Dim escritor As TextWriter
		escritor.Initialize(File.OpenOutput (File.DirRootExternal,"nomalism/entradas/fornecedores.txt",True))
		lista_fornecedores.TwoLinesLayout.Label.TextSize=16
		lista_fornecedores.TwoLinesLayout.Label.TextColor=Colors.Black
		'lista_fornecedores.TwoLinesLayout.Label.Typeface=FUTUR
		

		lista_fornecedores.TwoLinesLayout.SecondLabel.TextSize=14
		lista_fornecedores.TwoLinesLayout.SecondLabel.TextColor=Colors.Black
        'lista_fornecedores.TwoLinesLayout.SecondLabel.Typeface=FUTUR
		
		 For Each records() As Object In result.Rows
		   Dim campo1 As String =  records(result.Columns.Get("no"))
		   Dim campo2 As String =  records(result.Columns.Get("nome"))
		   Dim campo3 As String =  records(result.Columns.Get("conta"))
        	
			campo1=NumberFormat(campo1,3,0)
			
			campo2=st.left(campo2.ToUpperCase,30)
		Dim campo_escrever As String = campo1 &"|" & campo2 & "|" & campo3
		Dim campo_tabela1 As String = campo1 & "  -  " & campo2
		Dim campo_tabela2 As String = "             " & campo3	& " Pickings"	
		Dim campo_passar As String = campo1 &"|"& campo2
		'###########################3
		'######inserir na lista ####3
		'###########################3
		
		lista_fornecedores.AddTwoLines2(campo_tabela1,campo_tabela2,campo_passar)
		
		'###########################3
		'###########################3
		'###########################3
		escritor.WriteLine(campo_escrever)
		
		 Next
		 escritor.Close
       End If
	 
	End If 
   End If
   job.Release

End Sub


Sub procura_TextChanged (Old As String, New As String)
lista_fornecedores.Clear
Dim leitor As TextReader
Dim linha As String
Dim campo(), campo1, campo2 As String
leitor.Initialize(File.OpenInput(File.DirRootExternal,"nomalism/entradas/fornecedores.txt"))
linha=leitor.ReadLine
Do While linha <> Null
	If linha.ToUpperCase.Contains(procura.Text.ToUpperCase) Then
campo=Regex.Split("\|",linha)
	
			lista_fornecedores.TwoLinesLayout.Label.TextSize=16
		lista_fornecedores.TwoLinesLayout.Label.TextColor=Colors.Black
		'lista_fornecedores.TwoLinesLayout.Label.Typeface=FUTUR
		

		lista_fornecedores.TwoLinesLayout.SecondLabel.TextSize=14
		lista_fornecedores.TwoLinesLayout.SecondLabel.TextColor=Colors.Black
        'lista_fornecedores.TwoLinesLayout.SecondLabel.Typeface=FUTUR
		
		
			campo1=NumberFormat(campo(0),3,0)
			campo2=st.left(campo(1).ToUpperCase,30)
		'Dim campo_escrever As String = campo1 &"|" & campo2 & "|" & campo3
		Dim campo_tabela1 As String = campo1 & "|" & campo2
		Dim campo_tabela2 As String = "             " & campo(2)	& " Pickings"	
		'###########################3
		'######inserir na lista #############3
		'###########################3
		
		lista_fornecedores.AddTwoLines2(campo_tabela1,campo_tabela2, campo_tabela1)
		
		'###########################3
		'###########################3
		'###########################3
	End If
linha=leitor.ReadLine	
Loop
leitor.Close

End Sub


Sub lista_fornecedores_ItemClick (Position As Int, Value As Object)

Dim resposta As Int
resposta = Msgbox2 (Value ,"Criar Entrada ?","Sim","","Não",LoadBitmap(File.DirAssets,"favicon.png"))
If resposta=DialogResponse.POSITIVE Then 
	'#############3 abre ficheiro de fornecedor e escreve numero ############
	Dim leitor As String
leitor=File.ReadString(File.DirRootExternal,"nomalism/entradas/numero_entrada.txt")
leitor=leitor&"|"&Value
File.WriteString(File.DirRootExternal,"nomalism/entradas/numero_entrada.txt",leitor)

FORNECEDOR=st.right(Value,st.Len(Value)-4)
numero_forn= st.Left(Value,3)
File.WriteString(	File.DirRootExternal,"nomalism/entradas/" & numero_forn & ".txt" , "")
 File.Delete(File.DirRootExternal,"nomalism/entradas/pickings.txt")
StartActivity(ENTRADA)
Activity.Finish
Else
End If
	
	

End Sub